﻿using System;
using System.Diagnostics;

namespace IvanKuzminExam
{
    public class NumberAnalysis
    {
        public int Number { get; set; }

        // Конструктор для класса с подачей целого числа
        public NumberAnalysis(int number)
        {
            Debug.WriteLine($"Вызван конструктор класса NumberAnalysis с числом {number}.\n");
            Number = number;
        }

        // Конструктор для класса с вводом через консоль
        public NumberAnalysis()
        {
            Debug.WriteLine("Вызван конструктор класса NumberAnalysis с вводом через консоль.\n");
            InputNumberFromConsole();
        }

        // Не тестируется в написанных юнит тестах, так как это ввод с консоли
        // Вроде бы этого не нужно было делать, но оставляю на всякий случай
        public void InputNumberFromConsole()
        {
            Console.WriteLine("NumberAnalysis Constructor:");
            Console.Write("- Введите целое число: ");

            // бесконечный ввод, пока не будет получено целое число
            while (true)
            {
                try
                {
                    string input = Console.ReadLine(); // null exception будет пойман ниже

                    if (string.IsNullOrEmpty(input)) // на всякий случай проверяем на null и пустую строку
                    {
                        throw new Exception();
                    }

                    Number = int.Parse(input);
                }
                // ловим эксепшены от ввода и парсинга в int
                catch
                {
                    Console.WriteLine("Неверный ввод.");
                    Console.Write("- Введите целое число: ");
                }
            }
        }

        // Метод для проверки числа на положительное
        public bool IsPositive()
        {
            Debug.WriteLine("Вызван IsPositive() метод класса NumberAnalysis.");
            if (this.Number > 0)
            {
                Debug.WriteLine("Метод IsPositive() вернул true.\n");
                return true;
            }
            Debug.WriteLine("Метод IsPositive() вернул false.\n");

            return false;
        }

        // Метод для проверки числа на отрицательное
        public bool IsNegative()
        {
            Debug.WriteLine("Вызван IsNegative() метод класса NumberAnalysis.");

            if (this.Number < 0)
            {
                Debug.WriteLine("Метод IsNegative() вернул true.\n");

                return true;
            }
            Debug.WriteLine("Метод IsNegative() вернул false.\n");

            return false;
        }

        // Метод для проверки числа на нулевое
        public bool IsZero()
        {
            Debug.WriteLine("Вызван IsZero() метод класса NumberAnalysis.");

            if (this.Number == 0)
            {
                Debug.WriteLine("Метод IsZero() вернул true.\n");

                return true;
            }
            Debug.WriteLine("Метод IsZero() вернул false.\n");

            return false;
        }

        // Метод для проверки числа на четность
        public bool IsEven()
        {
            Debug.WriteLine("Вызван IsEven() метод класса NumberAnalysis.");

            if (this.Number % 2 == 0)
            {
                Debug.WriteLine("Метод IsEven() вернул true.\n");

                return true;
            }
            Debug.WriteLine("Метод IsEven() вернул false.\n");

            return false;
        }

        // Метод для проверки числа на простое
        public bool IsPrime()
        {
            Debug.WriteLine("Вызван IsPrime() метод класса NumberAnalysis.");

            if (Number <= 1)
            {
                Debug.WriteLine($"Число {Number} - это не простое и не составное число.");
                return false;  // 0 и 1 - не простые и не составные
            }

            List<int> divisors = new List<int>();
            bool isPrime = true;

            for (int i = 2; i < Number; i++)
            {
                if (Number % i == 0)
                {
                    isPrime = false;
                    divisors.Add(i);
                }
            }

            if (isPrime)
            {
                Debug.WriteLine($"Число {Number} - это простое число.");
                Debug.WriteLine("");

                return true;
            }
            else
            {
                Debug.WriteLine($"Число {Number} - это составное число.");
                Debug.WriteLine("Список делителей этого числа:");

                foreach (var divisor in divisors)
                {
                    Debug.WriteLine(divisor);
                }

                Debug.WriteLine("");
                return false;
            }
        }
    }
}
